Peter Stuge | 09377b7 | 2011-08-21 06:24:55 +0200 | [diff] [blame] | 1 | #!/bin/sh |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 2 | # |
Stefan Reinauer | 5f1ad89 | 2010-05-17 11:02:25 +0000 | [diff] [blame] | 3 | # Copyright (C) 2008-2010 by coresystems GmbH |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 4 | # written by Patrick Georgi <patrick.georgi@coresystems.de> and |
| 5 | # Stefan Reinauer <stefan.reinauer@coresystems.de> |
Stefan Reinauer | 14e2277 | 2010-04-27 06:56:47 +0000 | [diff] [blame] | 6 | # |
Marc Jones | 2aac3f6 | 2011-08-08 16:07:50 -0600 | [diff] [blame] | 7 | # Copyright (C) 2011 by Sage Electronic Engineering |
| 8 | # |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 9 | # This program is free software; you can redistribute it and/or modify |
| 10 | # it under the terms of the GNU General Public License as published by |
| 11 | # the Free Software Foundation; version 2 of the License. |
| 12 | # |
| 13 | # This program is distributed in the hope that it will be useful, |
| 14 | # but WITHOUT ANY WARRANTY; without even the implied warranty of |
| 15 | # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the |
| 16 | # GNU General Public License for more details. |
| 17 | # |
| 18 | # You should have received a copy of the GNU General Public License |
| 19 | # along with this program; if not, write to the Free Software |
Paul Menzel | a46a712 | 2013-02-23 18:37:27 +0100 | [diff] [blame] | 20 | # Foundation, Inc., 51 Franklin Street, Suite 500, Boston, MA 02110-1335, USA |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 21 | # |
| 22 | |
Patrick Georgi | 53c388f | 2015-03-07 09:55:18 +0100 | [diff] [blame] | 23 | CROSSGCC_DATE="March 8th, 2015" |
| 24 | CROSSGCC_VERSION="1.27" |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 25 | |
| 26 | # default settings |
| 27 | TARGETDIR=`pwd`/xgcc |
| 28 | TARGETARCH=i386-elf |
| 29 | DESTDIR= |
| 30 | |
| 31 | # version numbers |
Patrick Georgi | 53c388f | 2015-03-07 09:55:18 +0100 | [diff] [blame] | 32 | GMP_VERSION=6.0.0 |
Stefan Reinauer | 0d2119d | 2013-07-10 14:27:56 -0700 | [diff] [blame] | 33 | MPFR_VERSION=3.1.2 |
Paul Menzel | e661942 | 2015-02-23 10:33:59 +0100 | [diff] [blame] | 34 | MPC_VERSION=1.0.3 |
Stefan Reinauer | 5f1ad89 | 2010-05-17 11:02:25 +0000 | [diff] [blame] | 35 | LIBELF_VERSION=0.8.13 |
Patrick Georgi | 53c388f | 2015-03-07 09:55:18 +0100 | [diff] [blame] | 36 | GCC_VERSION=4.9.2 |
Stefan Reinauer | 0d2119d | 2013-07-10 14:27:56 -0700 | [diff] [blame] | 37 | GCC_AUTOCONF_VERSION=2.69 |
Patrick Georgi | 53c388f | 2015-03-07 09:55:18 +0100 | [diff] [blame] | 38 | BINUTILS_VERSION=2.25 |
| 39 | GDB_VERSION=7.9 |
| 40 | IASL_VERSION=20150204 |
| 41 | PYTHON_VERSION=3.4.3 |
Idwer Vollering | 296a015 | 2012-10-26 01:48:04 +0200 | [diff] [blame] | 42 | EXPAT_VERSION=2.1.0 |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 43 | |
| 44 | # archive locations |
Patrick Georgi | 53c388f | 2015-03-07 09:55:18 +0100 | [diff] [blame] | 45 | GMP_ARCHIVE="http://ftpmirror.gnu.org/gmp/gmp-${GMP_VERSION}a.tar.bz2" |
Patrick Georgi | 6e61ad3 | 2012-05-12 23:19:30 +0200 | [diff] [blame] | 46 | MPFR_ARCHIVE="http://ftpmirror.gnu.org/mpfr/mpfr-${MPFR_VERSION}.tar.bz2" |
Idwer Vollering | 7962fc7 | 2012-10-25 02:14:09 +0200 | [diff] [blame] | 47 | MPC_ARCHIVE="http://ftpmirror.gnu.org/mpc/mpc-${MPC_VERSION}.tar.gz" |
Stefan Reinauer | 5f1ad89 | 2010-05-17 11:02:25 +0000 | [diff] [blame] | 48 | LIBELF_ARCHIVE="http://www.mr511.de/software/libelf-${LIBELF_VERSION}.tar.gz" |
Idwer Vollering | 1cfee0b | 2012-10-25 02:03:53 +0200 | [diff] [blame] | 49 | GCC_ARCHIVE="http://ftpmirror.gnu.org/gcc/gcc-${GCC_VERSION}/gcc-${GCC_VERSION}.tar.bz2" |
Stefan Reinauer | 0d2119d | 2013-07-10 14:27:56 -0700 | [diff] [blame] | 50 | BINUTILS_ARCHIVE="http://ftpmirror.gnu.org/binutils/binutils-${BINUTILS_VERSION}.tar.bz2" |
Patrick Georgi | 53c388f | 2015-03-07 09:55:18 +0100 | [diff] [blame] | 51 | GDB_ARCHIVE="http://ftpmirror.gnu.org/gdb/gdb-${GDB_VERSION}.tar.xz" |
| 52 | IASL_ARCHIVE="https://acpica.org/sites/acpica/files/acpica-unix-${IASL_VERSION}.tar.gz" |
| 53 | PYTHON_ARCHIVE="http://www.python.org/ftp/python/${PYTHON_VERSION}/Python-${PYTHON_VERSION}.tar.xz" |
Stefan Reinauer | 2c3cd12 | 2011-11-01 21:43:50 +0100 | [diff] [blame] | 54 | EXPAT_ARCHIVE="http://downloads.sourceforge.net/sourceforge/expat/expat-${EXPAT_VERSION}.tar.gz" |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 55 | |
| 56 | GMP_DIR="gmp-${GMP_VERSION}" |
| 57 | MPFR_DIR="mpfr-${MPFR_VERSION}" |
Stefan Reinauer | 5f1ad89 | 2010-05-17 11:02:25 +0000 | [diff] [blame] | 58 | MPC_DIR="mpc-${MPC_VERSION}" |
| 59 | LIBELF_DIR="libelf-${LIBELF_VERSION}" |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 60 | GCC_DIR="gcc-${GCC_VERSION}" |
| 61 | BINUTILS_DIR="binutils-${BINUTILS_VERSION}" |
| 62 | GDB_DIR="gdb-${GDB_VERSION}" |
Marc Jones | 2aac3f6 | 2011-08-08 16:07:50 -0600 | [diff] [blame] | 63 | IASL_DIR="acpica-unix-${IASL_VERSION}" |
Stefan Reinauer | 2c3cd12 | 2011-11-01 21:43:50 +0100 | [diff] [blame] | 64 | PYTHON_DIR="Python-${PYTHON_VERSION}" |
| 65 | EXPAT_DIR="expat-${EXPAT_VERSION}" |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 66 | |
Patrick Georgi | 6321f52 | 2015-02-27 23:36:26 +0100 | [diff] [blame] | 67 | unset MAKELEVEL MAKEFLAGS |
| 68 | |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 69 | SAVETEMPS=0 |
Stefan Reinauer | 2c3cd12 | 2011-11-01 21:43:50 +0100 | [diff] [blame] | 70 | SKIPGDB=1 |
| 71 | SKIPPYTHON=1 |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 72 | |
Patrick Georgi | 1861ff7 | 2011-10-31 12:15:55 +0100 | [diff] [blame] | 73 | red='\033[0;31m' |
| 74 | RED='\033[1;31m' |
| 75 | green='\033[0;32m' |
| 76 | GREEN='\033[1;32m' |
| 77 | blue='\033[0;34m' |
| 78 | BLUE='\033[1;34m' |
| 79 | cyan='\033[0;36m' |
| 80 | CYAN='\033[1;36m' |
| 81 | NC='\033[0m' # No Color |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 82 | |
Stefan Reinauer | 0d2119d | 2013-07-10 14:27:56 -0700 | [diff] [blame] | 83 | UNAME=`uname` |
| 84 | |
Patrick Georgi | 198d23c | 2012-12-08 08:02:44 +0100 | [diff] [blame] | 85 | normalize_dirs() |
| 86 | { |
| 87 | mkdir -p $DESTDIR$TARGETDIR/lib |
| 88 | test -d $DESTDIR$TARGETDIR/lib32 && mv $DESTDIR$TARGETDIR/lib32/* $DESTDIR$TARGETDIR/lib |
| 89 | test -d $DESTDIR$TARGETDIR/lib64 && mv $DESTDIR$TARGETDIR/lib64/* $DESTDIR$TARGETDIR/lib |
| 90 | rmdir -p $DESTDIR$TARGETDIR/lib32 $DESTDIR$TARGETDIR/lib64 |
| 91 | |
| 92 | perl -pi -e "s,/lib32,/lib," $DESTDIR$TARGETDIR/lib/*.la |
| 93 | perl -pi -e "s,/lib64,/lib," $DESTDIR$TARGETDIR/lib/*.la |
| 94 | } |
| 95 | |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 96 | searchgnu() |
| 97 | { |
| 98 | # $1 short name |
| 99 | # result: GNU version of that tool on stdout |
| 100 | # or no output if no GNU version was found |
| 101 | for i in "$1" "g$1" "gnu$1"; do |
| 102 | if test -x "`which $i 2>/dev/null`"; then |
Stefan Reinauer | 2c3cd12 | 2011-11-01 21:43:50 +0100 | [diff] [blame] | 103 | if test `$i --version 2>/dev/null |grep -c GNU` \ |
| 104 | -gt 0; then |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 105 | echo $i |
| 106 | return |
| 107 | fi |
| 108 | fi |
| 109 | done |
Andrew Wu | b67e9a1 | 2014-04-28 18:13:44 +0800 | [diff] [blame] | 110 | # A workaround for OSX 10.9 and some BSDs, whose nongnu |
| 111 | # patch and tar also work. |
| 112 | if [ $UNAME = "Darwin" -o $UNAME = "FreeBSD" -o $UNAME = "NetBSD" ]; then |
Zheng Bao | 36156ff | 2012-09-28 16:18:58 +0800 | [diff] [blame] | 113 | if [ $1 != "make" ]; then |
| 114 | if test -x "`which $1 2>/dev/null`"; then |
| 115 | echo $1 |
| 116 | return |
| 117 | fi |
| 118 | fi |
| 119 | fi |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 120 | printf "${RED}ERROR:${red} Missing toolchain: $1${NC}\n" >&2 |
| 121 | exit 1 |
| 122 | } |
| 123 | |
Patrick Georgi | 68df804 | 2011-07-17 11:36:10 +0200 | [diff] [blame] | 124 | TAR=`searchgnu tar` || exit $? |
| 125 | PATCH=`searchgnu patch` || exit $? |
| 126 | MAKE=`searchgnu make` || exit $? |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 127 | |
Patrick Georgi | 5fb2b5c | 2012-05-12 23:25:23 +0200 | [diff] [blame] | 128 | searchgnu m4 > /dev/null |
| 129 | searchgnu bison > /dev/null |
Patrick Georgi | 0a3f239 | 2012-11-20 12:04:32 +0100 | [diff] [blame] | 130 | |
| 131 | if ! flex --version > /dev/null 2> /dev/null; then |
| 132 | printf "${RED}ERROR:${red} Missing toolchain: flex${NC}\n" >&2 |
| 133 | exit 1 |
| 134 | fi |
Patrick Georgi | 5fb2b5c | 2012-05-12 23:25:23 +0200 | [diff] [blame] | 135 | |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 136 | cleanup() |
| 137 | { |
| 138 | printf "Cleaning up temporary files... " |
Patrick Georgi | 3af0aa2 | 2013-09-17 20:59:52 +0200 | [diff] [blame] | 139 | rm -rf ${BUILDDIRPREFIX}-* combined gcc-* gmp-* mpfr-* mpc-* libelf-* binutils-* |
Patrick Georgi | 969cd93 | 2012-12-07 13:13:53 +0100 | [diff] [blame] | 140 | rm -rf gdb-* acpica-* python-* expat-* |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 141 | printf "${green}ok${NC}\n" |
| 142 | } |
| 143 | |
| 144 | myhelp() |
| 145 | { |
Stefan Reinauer | 2c3cd12 | 2011-11-01 21:43:50 +0100 | [diff] [blame] | 146 | printf "Usage: $0 [-V] [-c] [-p <platform>] [-d <target directory>] [-D <dest dir>] [-G] [-S]\n" |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 147 | printf " $0 [-V|--version]\n" |
| 148 | printf " $0 [-h|--help]\n\n" |
| 149 | |
| 150 | printf "Options:\n" |
| 151 | printf " [-V|--version] print version number and exit\n" |
| 152 | printf " [-h|--help] print this help and exit\n" |
| 153 | printf " [-c|--clean] remove temporary files before build\n" |
| 154 | printf " [-t|--savetemps] don't remove temporary files after build\n" |
Patrick Georgi | c1a75b1 | 2011-11-04 21:37:14 +0100 | [diff] [blame] | 155 | printf " [-y|--ccache] Use ccache when building cross compiler\n" |
Patrick Georgi | 73166c7 | 2010-04-14 20:42:42 +0000 | [diff] [blame] | 156 | printf " [-j|--jobs <num>] run <num> jobs in parallel in make\n" |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 157 | printf " [-p|--platform <platform>] target platform to build cross compiler for\n" |
| 158 | printf " (defaults to $TARGETARCH)\n" |
| 159 | printf " [-d|--directory <target dir>] target directory to install cross compiler to\n" |
| 160 | printf " (defaults to $TARGETDIR)\n\n" |
| 161 | printf " [-D|--destdir <dest dir>] destination directory to install cross compiler to\n" |
Stefan Reinauer | 2c3cd12 | 2011-11-01 21:43:50 +0100 | [diff] [blame] | 162 | printf " (for RPM builds, default unset)\n" |
| 163 | printf " [-G|--gdb] build GNU debugger\n" |
| 164 | printf " [-S|--scripting] build scripting support for GDB\n\n" |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 165 | } |
| 166 | |
| 167 | myversion() |
| 168 | { |
| 169 | # version tag is always printed, so just print the license here |
| 170 | |
| 171 | cat << EOF |
Stefan Reinauer | 5f1ad89 | 2010-05-17 11:02:25 +0000 | [diff] [blame] | 172 | Copyright (C) 2008-2010 by coresystems GmbH |
Marc Jones | 2aac3f6 | 2011-08-08 16:07:50 -0600 | [diff] [blame] | 173 | Copyright (C) 2011 by Sage Electronic Engineering |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 174 | |
| 175 | This program is free software; you can redistribute it and/or modify |
| 176 | it under the terms of the GNU General Public License as published by |
| 177 | the Free Software Foundation; version 2 of the License. |
| 178 | |
| 179 | This program is distributed in the hope that it will be useful, |
| 180 | but WITHOUT ANY WARRANTY; without even the implied warranty of |
| 181 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the |
| 182 | GNU General Public License for more details. |
| 183 | |
| 184 | EOF |
| 185 | } |
| 186 | |
Stefan Reinauer | 9491b4d | 2011-10-11 22:37:59 -0700 | [diff] [blame] | 187 | printf "${blue}Welcome to the ${red}coreboot${blue} cross toolchain builder v$CROSSGCC_VERSION ($CROSSGCC_DATE)${NC}\n\n" |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 188 | |
Patrick Georgi | 6bba29f | 2010-01-29 17:40:52 +0000 | [diff] [blame] | 189 | # Look if we have getopt. If not, build it. |
| 190 | export PATH=$PATH:. |
| 191 | getopt - > /dev/null 2>/dev/null || gcc -o getopt getopt.c |
| 192 | |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 193 | # parse parameters.. try to find out whether we're running GNU getopt |
Peter Stuge | 09377b7 | 2011-08-21 06:24:55 +0200 | [diff] [blame] | 194 | getoptbrand="`getopt -V | sed -e '1!d' -e 's,^\(......\).*,\1,'`" |
| 195 | if [ "${getoptbrand}" = "getopt" ]; then |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 196 | # Detected GNU getopt that supports long options. |
Patrick Georgi | c1a75b1 | 2011-11-04 21:37:14 +0100 | [diff] [blame] | 197 | args=`getopt -l version,help,clean,directory:,platform:,jobs:,destdir:,savetemps,skip-gdb,ccache Vhcd:p:j:D:tGy -- "$@"` |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 198 | eval set "$args" |
| 199 | else |
| 200 | # Detected non-GNU getopt |
Patrick Georgi | c1a75b1 | 2011-11-04 21:37:14 +0100 | [diff] [blame] | 201 | args=`getopt Vhcd:p:j:D:tGy $*` |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 202 | set -- $args |
| 203 | fi |
| 204 | |
| 205 | if [ $? != 0 ]; then |
| 206 | myhelp |
| 207 | exit 1 |
| 208 | fi |
| 209 | |
| 210 | while true ; do |
| 211 | case "$1" in |
| 212 | -V|--version) shift; myversion; exit 0;; |
| 213 | -h|--help) shift; myhelp; exit 0;; |
Patrick Georgi | 44af57a | 2013-12-19 22:06:22 +0100 | [diff] [blame] | 214 | -c|--clean) shift; clean=1;; |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 215 | -t|--savetemps) shift; SAVETEMPS=1;; |
| 216 | -d|--directory) shift; TARGETDIR="$1"; shift;; |
| 217 | -p|--platform) shift; TARGETARCH="$1"; shift;; |
| 218 | -D|--destdir) shift; DESTDIR="$1"; shift;; |
Patrick Georgi | 73166c7 | 2010-04-14 20:42:42 +0000 | [diff] [blame] | 219 | -j|--jobs) shift; JOBS="-j $1"; shift;; |
Stefan Reinauer | 2c3cd12 | 2011-11-01 21:43:50 +0100 | [diff] [blame] | 220 | -G|--gdb) shift; SKIPGDB=0;; |
| 221 | -S|--scripting) shift; SKIPPYTHON=0;; |
Patrick Georgi | c1a75b1 | 2011-11-04 21:37:14 +0100 | [diff] [blame] | 222 | -y|--ccache) shift; USECCACHE=1;; |
Patrick Georgi | d2e0dd5 | 2013-06-09 08:05:45 +0200 | [diff] [blame] | 223 | --) shift; break;; |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 224 | -*) printf "Invalid option\n\n"; myhelp; exit 1;; |
Patrick Georgi | d2e0dd5 | 2013-06-09 08:05:45 +0200 | [diff] [blame] | 225 | *) break;; |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 226 | esac |
| 227 | done |
| 228 | |
Ronald G. Minnich | b460a66 | 2013-05-26 05:33:35 -0700 | [diff] [blame] | 229 | case "$TARGETARCH" in |
David Hubbard | 5b0420a | 2013-05-28 16:33:15 -0600 | [diff] [blame] | 230 | i386-elf) ;; |
| 231 | i386-mingw32) ;; |
Patrick Georgi | 9b7efa5 | 2015-03-08 09:20:36 +0100 | [diff] [blame] | 232 | mipsel-elf) ;; |
Patrick Georgi | f0bbc95 | 2015-03-07 10:57:25 +0100 | [diff] [blame^] | 233 | riscv-elf) ;; |
Ronald G. Minnich | b460a66 | 2013-05-26 05:33:35 -0700 | [diff] [blame] | 234 | i386*) TARGETARCH=i386-elf;; |
Patrick Georgi | c888326 | 2013-09-19 10:57:58 +0200 | [diff] [blame] | 235 | arm*) TARGETARCH=armv7-a-eabi;; |
Stefan Reinauer | 0d2119d | 2013-07-10 14:27:56 -0700 | [diff] [blame] | 236 | aarch64*) TARGETARCH=aarch64-elf;; |
| 237 | *) printf "${red}WARNING: Unsupported architecture $TARGETARCH.${NC}\n\n"; ;; |
Ronald G. Minnich | b460a66 | 2013-05-26 05:33:35 -0700 | [diff] [blame] | 238 | esac |
| 239 | |
| 240 | echo "Target arch is now $TARGETARCH" |
Patrick Georgi | 3af0aa2 | 2013-09-17 20:59:52 +0200 | [diff] [blame] | 241 | BUILDDIRPREFIX=build-${TARGETARCH} |
| 242 | |
Patrick Georgi | 44af57a | 2013-12-19 22:06:22 +0100 | [diff] [blame] | 243 | if [ "$clean" = "1" ]; then |
| 244 | cleanup |
| 245 | fi |
| 246 | |
Peter Stuge | ceacd77 | 2011-06-09 04:54:16 +0200 | [diff] [blame] | 247 | GDB_PACKAGE="GDB" |
Stefan Reinauer | 2c3cd12 | 2011-11-01 21:43:50 +0100 | [diff] [blame] | 248 | PYTHON_PACKAGE="PYTHON" |
| 249 | EXPAT_PACKAGE="EXPAT" |
Peter Stuge | ceacd77 | 2011-06-09 04:54:16 +0200 | [diff] [blame] | 250 | if [ $SKIPGDB -eq 1 ]; then |
| 251 | printf "Will skip GDB ... ${green}ok${NC}\n" |
Peter Stuge | 0e8ee81 | 2011-08-28 11:04:23 +0200 | [diff] [blame] | 252 | GDB_ARCHIVE="" |
Peter Stuge | ceacd77 | 2011-06-09 04:54:16 +0200 | [diff] [blame] | 253 | GDB_PACKAGE="" |
Stefan Reinauer | 2c3cd12 | 2011-11-01 21:43:50 +0100 | [diff] [blame] | 254 | if [ $SKIPPYTHON -eq 0 ]; then |
| 255 | printf "Python scripting needs GDB ... disabling ... ${green}ok${NC}\n" |
| 256 | SKIPPYTHON=1 |
| 257 | fi |
| 258 | fi |
| 259 | if [ $SKIPPYTHON -eq 1 ]; then |
Jonathan A. Kollasch | 2d7ab4c | 2011-11-07 13:05:18 -0600 | [diff] [blame] | 260 | PYTHON_ARCHIVE="" |
Stefan Reinauer | 2c3cd12 | 2011-11-01 21:43:50 +0100 | [diff] [blame] | 261 | PYTHON_PACKAGE="" |
Jonathan A. Kollasch | 2d7ab4c | 2011-11-07 13:05:18 -0600 | [diff] [blame] | 262 | EXPAT_ARCHIVE="" |
Stefan Reinauer | 2c3cd12 | 2011-11-01 21:43:50 +0100 | [diff] [blame] | 263 | EXPAT_PACKAGE="" |
Peter Stuge | ceacd77 | 2011-06-09 04:54:16 +0200 | [diff] [blame] | 264 | fi |
| 265 | |
Stefan Reinauer | 9491b4d | 2011-10-11 22:37:59 -0700 | [diff] [blame] | 266 | # coreboot does not like the GOLD linker |
| 267 | # USE_GOLD="--enable-gold" |
| 268 | USE_GOLD="" |
| 269 | GCC_OPTIONS="--enable-lto" |
Stefan Reinauer | 5f1ad89 | 2010-05-17 11:02:25 +0000 | [diff] [blame] | 270 | |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 271 | printf "Downloading tar balls ... \n" |
| 272 | mkdir -p tarballs |
Stefan Reinauer | 2c3cd12 | 2011-11-01 21:43:50 +0100 | [diff] [blame] | 273 | for ARCHIVE in $GMP_ARCHIVE $MPFR_ARCHIVE $MPC_ARCHIVE $LIBELF_ARCHIVE \ |
Patrick Georgi | 969cd93 | 2012-12-07 13:13:53 +0100 | [diff] [blame] | 274 | $GCC_ARCHIVE $BINUTILS_ARCHIVE $GDB_ARCHIVE \ |
Stefan Reinauer | 2c3cd12 | 2011-11-01 21:43:50 +0100 | [diff] [blame] | 275 | $IASL_ARCHIVE $PYTHON_ARCHIVE $EXPAT_ARCHIVE; do |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 276 | FILE=`basename $ARCHIVE` |
| 277 | printf " * $FILE " |
| 278 | test -f tarballs/$FILE && printf "(cached)" || ( |
| 279 | printf "(downloading)" |
| 280 | cd tarballs |
Patrick Georgi | 6e61ad3 | 2012-05-12 23:19:30 +0200 | [diff] [blame] | 281 | wget --no-check-certificate -q $ARCHIVE |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 282 | ) |
Stefan Reinauer | 2c3cd12 | 2011-11-01 21:43:50 +0100 | [diff] [blame] | 283 | test -f tarballs/$FILE || \ |
Zheng Bao | 5b209c0 | 2012-09-20 16:09:51 +0800 | [diff] [blame] | 284 | printf "\n${RED}Failed to download $FILE.${NC}\n" |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 285 | test -f tarballs/$FILE || exit 1 |
| 286 | printf "\n" |
| 287 | done |
| 288 | printf "Downloaded tar balls ... " |
| 289 | printf "${green}ok${NC}\n" |
| 290 | |
| 291 | printf "Unpacking and patching ... \n" |
Stefan Reinauer | 2c3cd12 | 2011-11-01 21:43:50 +0100 | [diff] [blame] | 292 | for PACKAGE in GMP MPFR MPC LIBELF GCC BINUTILS $PYTHON_PACKAGE \ |
Patrick Georgi | 969cd93 | 2012-12-07 13:13:53 +0100 | [diff] [blame] | 293 | $EXPAT_PACKAGE $GDB_PACKAGE IASL; do |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 294 | archive=$PACKAGE"_ARCHIVE" |
Peter Stuge | 09377b7 | 2011-08-21 06:24:55 +0200 | [diff] [blame] | 295 | archive="`eval echo '$'$archive`" |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 296 | dir=$PACKAGE"_DIR" |
Peter Stuge | 09377b7 | 2011-08-21 06:24:55 +0200 | [diff] [blame] | 297 | dir="`eval echo '$'${dir}`" |
Zheng Bao | f95bb2d | 2013-12-13 12:30:46 +0800 | [diff] [blame] | 298 | test -d ${dir} && test -f ${dir}/.unpack_success || ( |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 299 | printf " * `basename $archive`\n" |
| 300 | FLAGS=zxf |
Peter Stuge | 09377b7 | 2011-08-21 06:24:55 +0200 | [diff] [blame] | 301 | suffix=`echo $archive | sed 's,.*\.,,'` |
| 302 | test "$suffix" = "gz" && FLAGS=zxf |
| 303 | test "$suffix" = "bz2" && FLAGS=jxf |
Patrick Georgi | 53c388f | 2015-03-07 09:55:18 +0100 | [diff] [blame] | 304 | test "$suffix" = "xz" && FLAGS="--xz -xf" |
Peter Stuge | 09377b7 | 2011-08-21 06:24:55 +0200 | [diff] [blame] | 305 | test "$suffix" = "lzma" && FLAGS="--lzma -xf" |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 306 | $TAR $FLAGS tarballs/`basename $archive` |
Peter Stuge | 09377b7 | 2011-08-21 06:24:55 +0200 | [diff] [blame] | 307 | for patch in patches/${dir}_*.patch; do |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 308 | test -r $patch || continue |
| 309 | printf " o `basename $patch`\n" |
Stefan Reinauer | 2c3cd12 | 2011-11-01 21:43:50 +0100 | [diff] [blame] | 310 | $PATCH -s -N -p0 < `echo $patch` || \ |
Zheng Bao | 5b209c0 | 2012-09-20 16:09:51 +0800 | [diff] [blame] | 311 | printf "\n${RED}Failed $patch.${NC}\n" |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 312 | done |
Zheng Bao | 691b313c | 2013-12-09 14:09:07 +0800 | [diff] [blame] | 313 | touch ${dir}/.unpack_success |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 314 | ) |
| 315 | done |
| 316 | printf "Unpacked and patched ... " |
| 317 | printf "${green}ok${NC}\n" |
| 318 | |
Stefan Reinauer | 9491b4d | 2011-10-11 22:37:59 -0700 | [diff] [blame] | 319 | CC=cc |
Stefan Reinauer | 0d2119d | 2013-07-10 14:27:56 -0700 | [diff] [blame] | 320 | if [ $UNAME = "Darwin" ]; then |
Stefan Reinauer | 5f1ad89 | 2010-05-17 11:02:25 +0000 | [diff] [blame] | 321 | #GCC_OPTIONS="$GCC_OPTIONS --enable-threads=posix" |
| 322 | |
| 323 | # generally the OS X compiler can create x64 binaries. |
| 324 | # Per default it generated i386 binaries in 10.5 and x64 |
| 325 | # binaries in 10.6 (even if the kernel is 32bit) |
| 326 | # For some weird reason, 10.5 autodetects an ABI=64 though |
| 327 | # so we're setting the ABI explicitly here. |
Zheng Bao | 04ceed6 | 2012-10-23 19:41:25 +0800 | [diff] [blame] | 328 | if [ `sysctl -n hw.optional.x86_64 2>/dev/null` -eq 1 ] 2>/dev/null; then |
Stefan Reinauer | 5f1ad89 | 2010-05-17 11:02:25 +0000 | [diff] [blame] | 329 | OPTIONS="ABI=64" |
| 330 | else |
| 331 | OPTIONS="ABI=32" |
| 332 | fi |
Stefan Reinauer | 9491b4d | 2011-10-11 22:37:59 -0700 | [diff] [blame] | 333 | |
Stefan Reinauer | 4266b92 | 2012-12-05 16:18:32 -0800 | [diff] [blame] | 334 | # In Xcode 4.5.2 the default compiler is clang. |
| 335 | # However, this compiler fails to compile gcc 4.7.x. As a |
| 336 | # workaround it's possible to compile gcc with llvm-gcc. |
Stefan Reinauer | 9491b4d | 2011-10-11 22:37:59 -0700 | [diff] [blame] | 337 | if $CC -v 2>&1 | grep -q LLVM; then |
Stefan Reinauer | 4266b92 | 2012-12-05 16:18:32 -0800 | [diff] [blame] | 338 | CC=llvm-gcc |
Stefan Reinauer | 9491b4d | 2011-10-11 22:37:59 -0700 | [diff] [blame] | 339 | fi |
Stefan Reinauer | 5f1ad89 | 2010-05-17 11:02:25 +0000 | [diff] [blame] | 340 | fi |
| 341 | |
Patrick Georgi | c1a75b1 | 2011-11-04 21:37:14 +0100 | [diff] [blame] | 342 | if [ "$USECCACHE" = 1 ]; then |
| 343 | CC="ccache $CC" |
| 344 | fi |
| 345 | |
Patrick Georgi | 3af0aa2 | 2013-09-17 20:59:52 +0200 | [diff] [blame] | 346 | mkdir -p ${BUILDDIRPREFIX}-gmp ${BUILDDIRPREFIX}-mpfr ${BUILDDIRPREFIX}-mpc ${BUILDDIRPREFIX}-libelf ${BUILDDIRPREFIX}-binutils \ |
| 347 | ${BUILDDIRPREFIX}-gcc ${BUILDDIRPREFIX}-python ${BUILDDIRPREFIX}-expat |
Stefan Reinauer | 16bd789 | 2012-12-07 23:57:01 +0100 | [diff] [blame] | 348 | |
| 349 | mkdir -p $DESTDIR$TARGETDIR/bin |
| 350 | export PATH=$DESTDIR$TARGETDIR/bin:$PATH |
| 351 | |
Peter Stuge | ceacd77 | 2011-06-09 04:54:16 +0200 | [diff] [blame] | 352 | if [ $SKIPGDB -eq 0 ]; then |
Patrick Georgi | 3af0aa2 | 2013-09-17 20:59:52 +0200 | [diff] [blame] | 353 | mkdir -p ${BUILDDIRPREFIX}-gdb |
Peter Stuge | ceacd77 | 2011-06-09 04:54:16 +0200 | [diff] [blame] | 354 | fi |
Patrick Georgi | 3af0aa2 | 2013-09-17 20:59:52 +0200 | [diff] [blame] | 355 | if [ -f ${BUILDDIRPREFIX}-gmp/.success ]; then |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 356 | printf "Skipping GMP as it is already built\n" |
| 357 | else |
| 358 | printf "Building GMP ${GMP_VERSION} ... " |
| 359 | ( |
Patrick Georgi | 3af0aa2 | 2013-09-17 20:59:52 +0200 | [diff] [blame] | 360 | cd ${BUILDDIRPREFIX}-gmp |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 361 | rm -f .failed |
Patrick Georgi | 643c9e8 | 2011-11-04 21:30:49 +0100 | [diff] [blame] | 362 | CC="$CC" ../${GMP_DIR}/configure --disable-shared --prefix=$TARGETDIR $OPTIONS \ |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 363 | || touch .failed |
Patrick Georgi | 73166c7 | 2010-04-14 20:42:42 +0000 | [diff] [blame] | 364 | $MAKE $JOBS || touch .failed |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 365 | $MAKE install DESTDIR=$DESTDIR || touch .failed |
Patrick Georgi | 198d23c | 2012-12-08 08:02:44 +0100 | [diff] [blame] | 366 | |
| 367 | normalize_dirs |
| 368 | |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 369 | if [ ! -f .failed ]; then touch .success; fi |
Patrick Georgi | 3af0aa2 | 2013-09-17 20:59:52 +0200 | [diff] [blame] | 370 | ) > ${BUILDDIRPREFIX}-gmp/crossgcc-build.log 2>&1 |
| 371 | test -r ${BUILDDIRPREFIX}-gmp/.failed && printf "${RED}failed${NC}\n" || \ |
Stefan Reinauer | 2c3cd12 | 2011-11-01 21:43:50 +0100 | [diff] [blame] | 372 | printf "${green}ok${NC}\n" |
Patrick Georgi | 3af0aa2 | 2013-09-17 20:59:52 +0200 | [diff] [blame] | 373 | test -r ${BUILDDIRPREFIX}-gmp/.failed && exit 1 |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 374 | fi |
| 375 | |
Stefan Reinauer | 9491b4d | 2011-10-11 22:37:59 -0700 | [diff] [blame] | 376 | # Now set CFLAGS to match GMP CFLAGS but strip out -pedantic |
| 377 | # as GCC 4.6.x fails if it's there. |
| 378 | HOSTCFLAGS=`grep __GMP_CFLAGS $DESTDIR$TARGETDIR/include/gmp.h |cut -d\" -f2 |\ |
| 379 | sed s,-pedantic,,` |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 380 | |
Patrick Georgi | 3af0aa2 | 2013-09-17 20:59:52 +0200 | [diff] [blame] | 381 | if [ -f ${BUILDDIRPREFIX}-mpfr/.success ]; then |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 382 | printf "Skipping MPFR as it is already built\n" |
| 383 | else |
| 384 | printf "Building MPFR ${MPFR_VERSION} ... " |
| 385 | ( |
Stefan Reinauer | 0d2119d | 2013-07-10 14:27:56 -0700 | [diff] [blame] | 386 | test $UNAME = "Darwin" && CFLAGS="$CFLAGS -force_cpusubtype_ALL" |
Patrick Georgi | 3af0aa2 | 2013-09-17 20:59:52 +0200 | [diff] [blame] | 387 | cd ${BUILDDIRPREFIX}-mpfr |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 388 | rm -f .failed |
Patrick Georgi | 643c9e8 | 2011-11-04 21:30:49 +0100 | [diff] [blame] | 389 | CC="$CC" ../${MPFR_DIR}/configure --disable-shared --prefix=$TARGETDIR \ |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 390 | --infodir=$TARGETDIR/info \ |
Stefan Reinauer | 2c3cd12 | 2011-11-01 21:43:50 +0100 | [diff] [blame] | 391 | --with-gmp=$DESTDIR$TARGETDIR CFLAGS="$HOSTCFLAGS" || \ |
| 392 | touch .failed |
Patrick Georgi | 73166c7 | 2010-04-14 20:42:42 +0000 | [diff] [blame] | 393 | $MAKE $JOBS || touch .failed |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 394 | $MAKE install DESTDIR=$DESTDIR || touch .failed |
| 395 | |
Patrick Georgi | 198d23c | 2012-12-08 08:02:44 +0100 | [diff] [blame] | 396 | normalize_dirs |
| 397 | |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 398 | # work around build problem of libgmp.la |
| 399 | if [ "$DESTDIR" != "" ]; then |
| 400 | perl -pi -e "s,$DESTDIR,," $DESTDIR$TARGETDIR/libgmp.la |
| 401 | fi |
| 402 | |
| 403 | if [ ! -f .failed ]; then touch .success; fi |
Patrick Georgi | 3af0aa2 | 2013-09-17 20:59:52 +0200 | [diff] [blame] | 404 | ) > ${BUILDDIRPREFIX}-mpfr/crossgcc-build.log 2>&1 |
| 405 | test -r ${BUILDDIRPREFIX}-mpfr/.failed && printf "${RED}failed${NC}\n" || \ |
Stefan Reinauer | 2c3cd12 | 2011-11-01 21:43:50 +0100 | [diff] [blame] | 406 | printf "${green}ok${NC}\n" |
Patrick Georgi | 3af0aa2 | 2013-09-17 20:59:52 +0200 | [diff] [blame] | 407 | test -r ${BUILDDIRPREFIX}-mpfr/.failed && exit 1 |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 408 | fi |
| 409 | |
Patrick Georgi | 3af0aa2 | 2013-09-17 20:59:52 +0200 | [diff] [blame] | 410 | if [ -f ${BUILDDIRPREFIX}-mpc/.success ]; then |
Stefan Reinauer | 5f1ad89 | 2010-05-17 11:02:25 +0000 | [diff] [blame] | 411 | printf "Skipping MPC as it is already built\n" |
| 412 | else |
| 413 | printf "Building MPC ${MPC_VERSION} ... " |
| 414 | ( |
Patrick Georgi | 3af0aa2 | 2013-09-17 20:59:52 +0200 | [diff] [blame] | 415 | cd ${BUILDDIRPREFIX}-mpc |
Stefan Reinauer | 5f1ad89 | 2010-05-17 11:02:25 +0000 | [diff] [blame] | 416 | rm -f .failed |
Patrick Georgi | 643c9e8 | 2011-11-04 21:30:49 +0100 | [diff] [blame] | 417 | CC="$CC" ../${MPC_DIR}/configure --disable-shared --prefix=$TARGETDIR \ |
Stefan Reinauer | 5f1ad89 | 2010-05-17 11:02:25 +0000 | [diff] [blame] | 418 | --infodir=$TARGETDIR/info --with-mpfr=$DESTDIR$TARGETDIR \ |
Stefan Reinauer | 2c3cd12 | 2011-11-01 21:43:50 +0100 | [diff] [blame] | 419 | --with-gmp=$DESTDIR$TARGETDIR CFLAGS="$HOSTCFLAGS" || \ |
| 420 | touch .failed |
Stefan Reinauer | 5f1ad89 | 2010-05-17 11:02:25 +0000 | [diff] [blame] | 421 | $MAKE $JOBS || touch .failed |
| 422 | $MAKE install DESTDIR=$DESTDIR || touch .failed |
| 423 | |
Patrick Georgi | 198d23c | 2012-12-08 08:02:44 +0100 | [diff] [blame] | 424 | normalize_dirs |
| 425 | |
Stefan Reinauer | 5f1ad89 | 2010-05-17 11:02:25 +0000 | [diff] [blame] | 426 | if [ ! -f .failed ]; then touch .success; fi |
Patrick Georgi | 3af0aa2 | 2013-09-17 20:59:52 +0200 | [diff] [blame] | 427 | ) > ${BUILDDIRPREFIX}-mpc/crossgcc-build.log 2>&1 |
| 428 | test -r ${BUILDDIRPREFIX}-mpc/.failed && printf "${RED}failed${NC}\n" || \ |
Stefan Reinauer | 2c3cd12 | 2011-11-01 21:43:50 +0100 | [diff] [blame] | 429 | printf "${green}ok${NC}\n" |
Patrick Georgi | 3af0aa2 | 2013-09-17 20:59:52 +0200 | [diff] [blame] | 430 | test -r ${BUILDDIRPREFIX}-mpc/.failed && exit 1 |
Stefan Reinauer | 5f1ad89 | 2010-05-17 11:02:25 +0000 | [diff] [blame] | 431 | fi |
| 432 | |
Patrick Georgi | 3af0aa2 | 2013-09-17 20:59:52 +0200 | [diff] [blame] | 433 | if [ -f ${BUILDDIRPREFIX}-libelf/.success ]; then |
Stefan Reinauer | 5f1ad89 | 2010-05-17 11:02:25 +0000 | [diff] [blame] | 434 | printf "Skipping libelf as it is already built\n" |
| 435 | else |
| 436 | printf "Building libelf ${LIBELF_VERSION} ... " |
| 437 | ( |
Patrick Georgi | 3af0aa2 | 2013-09-17 20:59:52 +0200 | [diff] [blame] | 438 | cd ${BUILDDIRPREFIX}-libelf |
Stefan Reinauer | 5f1ad89 | 2010-05-17 11:02:25 +0000 | [diff] [blame] | 439 | rm -f .failed |
| 440 | echo "$HOSTCFLAGS" |
Patrick Georgi | 643c9e8 | 2011-11-04 21:30:49 +0100 | [diff] [blame] | 441 | CC="$CC" CFLAGS="$HOSTCFLAGS" libelf_cv_elf_h_works=no \ |
Stefan Reinauer | 2c3cd12 | 2011-11-01 21:43:50 +0100 | [diff] [blame] | 442 | ../${LIBELF_DIR}/configure --disable-shared --prefix=$TARGETDIR \ |
Stefan Reinauer | 5f1ad89 | 2010-05-17 11:02:25 +0000 | [diff] [blame] | 443 | --infodir=$TARGETDIR/info CFLAGS="$HOSTCFLAGS" || touch .failed |
| 444 | $MAKE $JOBS || touch .failed |
Scott Duplichan | 4270a97 | 2014-12-12 20:21:40 -0600 | [diff] [blame] | 445 | $MAKE install prefix=$DESTDIR$TARGETDIR || touch .failed |
Stefan Reinauer | 5f1ad89 | 2010-05-17 11:02:25 +0000 | [diff] [blame] | 446 | |
Patrick Georgi | 198d23c | 2012-12-08 08:02:44 +0100 | [diff] [blame] | 447 | normalize_dirs |
| 448 | |
Stefan Reinauer | 5f1ad89 | 2010-05-17 11:02:25 +0000 | [diff] [blame] | 449 | if [ ! -f .failed ]; then touch .success; fi |
Patrick Georgi | 3af0aa2 | 2013-09-17 20:59:52 +0200 | [diff] [blame] | 450 | ) > ${BUILDDIRPREFIX}-libelf/crossgcc-build.log 2>&1 |
| 451 | test -r ${BUILDDIRPREFIX}-libelf/.failed && printf "${RED}failed${NC}\n" || \ |
Stefan Reinauer | 2c3cd12 | 2011-11-01 21:43:50 +0100 | [diff] [blame] | 452 | printf "${green}ok${NC}\n" |
Patrick Georgi | 3af0aa2 | 2013-09-17 20:59:52 +0200 | [diff] [blame] | 453 | test -r ${BUILDDIRPREFIX}-libelf/.failed && exit 1 |
Stefan Reinauer | 5f1ad89 | 2010-05-17 11:02:25 +0000 | [diff] [blame] | 454 | fi |
| 455 | |
Patrick Georgi | 3af0aa2 | 2013-09-17 20:59:52 +0200 | [diff] [blame] | 456 | if [ -f ${BUILDDIRPREFIX}-binutils/.success ]; then |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 457 | printf "Skipping binutils as it is already built\n" |
| 458 | else |
| 459 | printf "Building binutils ${BINUTILS_VERSION} ... " |
| 460 | ( |
Stefan Reinauer | 9491b4d | 2011-10-11 22:37:59 -0700 | [diff] [blame] | 461 | # What a pain: binutils don't come with configure |
| 462 | # script anymore. Create it: |
| 463 | cd binutils-${BINUTILS_VERSION}/ |
| 464 | autoconf |
| 465 | cd .. |
| 466 | # Now build binutils |
Patrick Georgi | 3af0aa2 | 2013-09-17 20:59:52 +0200 | [diff] [blame] | 467 | cd ${BUILDDIRPREFIX}-binutils |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 468 | rm -f .failed |
Patrick Georgi | 643c9e8 | 2011-11-04 21:30:49 +0100 | [diff] [blame] | 469 | CC="$CC" ../binutils-${BINUTILS_VERSION}/configure --prefix=$TARGETDIR \ |
Stefan Reinauer | 2c3cd12 | 2011-11-01 21:43:50 +0100 | [diff] [blame] | 470 | --target=${TARGETARCH} --disable-werror --disable-nls \ |
| 471 | $USE_GOLD CFLAGS="$HOSTCFLAGS" || touch .failed |
Patrick Georgi | 73166c7 | 2010-04-14 20:42:42 +0000 | [diff] [blame] | 472 | $MAKE $JOBS || touch .failed |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 473 | $MAKE install DESTDIR=$DESTDIR || touch .failed |
| 474 | if [ ! -f .failed ]; then touch .success; fi |
Patrick Georgi | 3af0aa2 | 2013-09-17 20:59:52 +0200 | [diff] [blame] | 475 | ) > ${BUILDDIRPREFIX}-binutils/crossgcc-build.log 2>&1 |
| 476 | test -r ${BUILDDIRPREFIX}-binutils/.failed && printf "${RED}failed${NC}\n" || \ |
Stefan Reinauer | 2c3cd12 | 2011-11-01 21:43:50 +0100 | [diff] [blame] | 477 | printf "${green}ok${NC}\n" |
Patrick Georgi | 3af0aa2 | 2013-09-17 20:59:52 +0200 | [diff] [blame] | 478 | test -r ${BUILDDIRPREFIX}-binutils/.failed && exit 1 |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 479 | fi |
| 480 | |
Patrick Georgi | 3af0aa2 | 2013-09-17 20:59:52 +0200 | [diff] [blame] | 481 | if [ -f ${BUILDDIRPREFIX}-gcc/.success ]; then |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 482 | printf "Skipping GCC as it is already built\n" |
| 483 | else |
| 484 | printf "Building GCC ${GCC_VERSION} ... " |
| 485 | ( |
Stefan Reinauer | 9491b4d | 2011-10-11 22:37:59 -0700 | [diff] [blame] | 486 | # Even worse than binutils: GCC does not come with configure |
| 487 | # script anymore, but also enforces an obsolete autoconf version |
| 488 | # to create it. This is a poster child of how autotools help make |
| 489 | # software portable. |
| 490 | cd gcc-${GCC_VERSION} |
| 491 | sed '/dnl Ensure exactly this Autoconf version is used/d' \ |
| 492 | config/override.m4 > config/override.m4.new |
| 493 | autoconf_version=`autoconf -V | grep "autoconf" | tr ' ' '\n' | tail -1` |
| 494 | sed "s/${GCC_AUTOCONF_VERSION}/${autoconf_version}/g" \ |
| 495 | config/override.m4.new > config/override.m4 |
| 496 | autoconf |
| 497 | cd .. |
| 498 | # Now, finally, we can build gcc: |
Patrick Georgi | 3af0aa2 | 2013-09-17 20:59:52 +0200 | [diff] [blame] | 499 | cd ${BUILDDIRPREFIX}-gcc |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 500 | rm -f .failed |
| 501 | # GCC does not honour HOSTCFLAGS at all. CFLAGS are used for |
| 502 | # both target and host object files. This is pretty misdesigned. |
| 503 | # There's a work-around called CFLAGS_FOR_BUILD and CFLAGS_FOR_TARGET |
| 504 | # but it does not seem to work properly. At least the host library |
| 505 | # libiberty is not compiled with CFLAGS_FOR_BUILD. |
Stefan Reinauer | 9491b4d | 2011-10-11 22:37:59 -0700 | [diff] [blame] | 506 | CC="$CC" CFLAGS_FOR_TARGET="-O2" CFLAGS="$HOSTCFLAGS" \ |
| 507 | CFLAGS_FOR_BUILD="$HOSTCFLAGS" ../gcc-${GCC_VERSION}/configure \ |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 508 | --prefix=$TARGETDIR --libexecdir=$TARGETDIR/lib \ |
Stefan Reinauer | 6ade161 | 2010-01-16 16:44:20 +0000 | [diff] [blame] | 509 | --target=${TARGETARCH} --disable-werror --disable-shared \ |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 510 | --disable-libssp --disable-bootstrap --disable-nls \ |
Patrick Georgi | 969cd93 | 2012-12-07 13:13:53 +0100 | [diff] [blame] | 511 | --disable-libquadmath --without-headers \ |
Stefan Reinauer | 5f1ad89 | 2010-05-17 11:02:25 +0000 | [diff] [blame] | 512 | $GCC_OPTIONS --enable-languages="c" $USE_GOLD \ |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 513 | --with-gmp=$DESTDIR$TARGETDIR --with-mpfr=$DESTDIR$TARGETDIR \ |
Stefan Reinauer | 5f1ad89 | 2010-05-17 11:02:25 +0000 | [diff] [blame] | 514 | --with-mpc=$DESTDIR$TARGETDIR --with-libelf=$DESTDIR$TARGETDIR \ |
| 515 | --with-pkgversion="coreboot toolchain v$CROSSGCC_VERSION $CROSSGCC_DATE" \ |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 516 | || touch .failed |
Patrick Georgi | 969cd93 | 2012-12-07 13:13:53 +0100 | [diff] [blame] | 517 | $MAKE $JOBS CFLAGS_FOR_BUILD="$HOSTCFLAGS" all-gcc || touch .failed |
| 518 | $MAKE install-gcc DESTDIR=$DESTDIR || touch .failed |
| 519 | |
| 520 | if [ "`echo $TARGETARCH | grep -c -- -mingw32`" -eq 0 ]; then |
| 521 | $MAKE $JOBS CFLAGS_FOR_BUILD="$HOSTCFLAGS" all-target-libgcc || touch .failed |
| 522 | $MAKE install-target-libgcc DESTDIR=$DESTDIR || touch .failed |
| 523 | fi |
| 524 | |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 525 | if [ ! -f .failed ]; then touch .success; fi |
Patrick Georgi | 3af0aa2 | 2013-09-17 20:59:52 +0200 | [diff] [blame] | 526 | ) > ${BUILDDIRPREFIX}-gcc/crossgcc-build.log 2>&1 |
| 527 | test -r ${BUILDDIRPREFIX}-gcc/.failed && printf "${RED}failed${NC}\n" || \ |
Stefan Reinauer | 2c3cd12 | 2011-11-01 21:43:50 +0100 | [diff] [blame] | 528 | printf "${green}ok${NC}\n" |
Patrick Georgi | 3af0aa2 | 2013-09-17 20:59:52 +0200 | [diff] [blame] | 529 | test -r ${BUILDDIRPREFIX}-gcc/.failed && exit 1 |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 530 | fi |
| 531 | |
Patrick Georgi | 3af0aa2 | 2013-09-17 20:59:52 +0200 | [diff] [blame] | 532 | if [ -f ${BUILDDIRPREFIX}-expat/.success ]; then |
Stefan Reinauer | 2c3cd12 | 2011-11-01 21:43:50 +0100 | [diff] [blame] | 533 | printf "Skipping Expat as it is already built\n" |
Stefan Reinauer | 1200ec5 | 2011-11-01 22:39:41 +0100 | [diff] [blame] | 534 | elif [ $SKIPPYTHON -eq 1 ]; then |
| 535 | printf "Skipping Expat (Python scripting not enabled)\n" |
Stefan Reinauer | 2c3cd12 | 2011-11-01 21:43:50 +0100 | [diff] [blame] | 536 | else |
| 537 | printf "Building Expat ${EXPAT_VERSION} ... " |
| 538 | ( |
Patrick Georgi | 3af0aa2 | 2013-09-17 20:59:52 +0200 | [diff] [blame] | 539 | cd ${BUILDDIRPREFIX}-expat |
Stefan Reinauer | 2c3cd12 | 2011-11-01 21:43:50 +0100 | [diff] [blame] | 540 | rm -f .failed |
Patrick Georgi | 643c9e8 | 2011-11-04 21:30:49 +0100 | [diff] [blame] | 541 | CC="$CC" CFLAGS="$HOSTCFLAGS" ../${EXPAT_DIR}/configure --disable-shared \ |
Stefan Reinauer | 2c3cd12 | 2011-11-01 21:43:50 +0100 | [diff] [blame] | 542 | --prefix=$TARGETDIR --target=${TARGETARCH} || touch .failed |
| 543 | $MAKE || touch .failed |
| 544 | $MAKE install DESTDIR=$DESTDIR || touch .failed |
Patrick Georgi | 198d23c | 2012-12-08 08:02:44 +0100 | [diff] [blame] | 545 | |
| 546 | normalize_dirs |
| 547 | |
Stefan Reinauer | 2c3cd12 | 2011-11-01 21:43:50 +0100 | [diff] [blame] | 548 | if [ ! -f .failed ]; then touch .success; fi |
Patrick Georgi | 3af0aa2 | 2013-09-17 20:59:52 +0200 | [diff] [blame] | 549 | ) > ${BUILDDIRPREFIX}-expat/crossgcc-build.log 2>&1 |
| 550 | test -r ${BUILDDIRPREFIX}-expat/.failed && printf "${RED}failed${NC}\n" || \ |
Stefan Reinauer | 2c3cd12 | 2011-11-01 21:43:50 +0100 | [diff] [blame] | 551 | printf "${green}ok${NC}\n" |
Patrick Georgi | 3af0aa2 | 2013-09-17 20:59:52 +0200 | [diff] [blame] | 552 | test -r ${BUILDDIRPREFIX}-expat/.failed && exit 1 |
Stefan Reinauer | 2c3cd12 | 2011-11-01 21:43:50 +0100 | [diff] [blame] | 553 | fi |
| 554 | |
| 555 | |
Patrick Georgi | 3af0aa2 | 2013-09-17 20:59:52 +0200 | [diff] [blame] | 556 | if [ -f ${BUILDDIRPREFIX}-python/.success ]; then |
Stefan Reinauer | 2c3cd12 | 2011-11-01 21:43:50 +0100 | [diff] [blame] | 557 | printf "Skipping Python as it is already built\n" |
Stefan Reinauer | 1200ec5 | 2011-11-01 22:39:41 +0100 | [diff] [blame] | 558 | elif [ $SKIPPYTHON -eq 1 ]; then |
| 559 | printf "Skipping Python (Python scripting not enabled)\n" |
Stefan Reinauer | 2c3cd12 | 2011-11-01 21:43:50 +0100 | [diff] [blame] | 560 | else |
| 561 | printf "Building Python ${PYTHON_VERSION} ... " |
| 562 | ( |
Patrick Georgi | 3af0aa2 | 2013-09-17 20:59:52 +0200 | [diff] [blame] | 563 | cd ${BUILDDIRPREFIX}-python |
Stefan Reinauer | 2c3cd12 | 2011-11-01 21:43:50 +0100 | [diff] [blame] | 564 | rm -f .failed |
Patrick Georgi | 643c9e8 | 2011-11-04 21:30:49 +0100 | [diff] [blame] | 565 | CC="$CC" CFLAGS="$HOSTCFLAGS" ../${PYTHON_DIR}/configure --prefix=$TARGETDIR \ |
Stefan Reinauer | 2c3cd12 | 2011-11-01 21:43:50 +0100 | [diff] [blame] | 566 | --target=${TARGETARCH} || touch .failed |
| 567 | $MAKE $JOBS || touch .failed |
| 568 | $MAKE install DESTDIR=$DESTDIR || touch .failed |
Patrick Georgi | 198d23c | 2012-12-08 08:02:44 +0100 | [diff] [blame] | 569 | |
| 570 | normalize_dirs |
| 571 | |
Stefan Reinauer | 2c3cd12 | 2011-11-01 21:43:50 +0100 | [diff] [blame] | 572 | if [ ! -f .failed ]; then touch .success; fi |
Patrick Georgi | 3af0aa2 | 2013-09-17 20:59:52 +0200 | [diff] [blame] | 573 | ) > ${BUILDDIRPREFIX}-python/crossgcc-build.log 2>&1 |
| 574 | test -r ${BUILDDIRPREFIX}-python/.failed && printf "${RED}failed${NC}\n" || \ |
Stefan Reinauer | 2c3cd12 | 2011-11-01 21:43:50 +0100 | [diff] [blame] | 575 | printf "${green}ok${NC}\n" |
Patrick Georgi | 3af0aa2 | 2013-09-17 20:59:52 +0200 | [diff] [blame] | 576 | test -r ${BUILDDIRPREFIX}-python/.failed && exit 1 |
Stefan Reinauer | 2c3cd12 | 2011-11-01 21:43:50 +0100 | [diff] [blame] | 577 | fi |
| 578 | |
| 579 | |
Patrick Georgi | 3af0aa2 | 2013-09-17 20:59:52 +0200 | [diff] [blame] | 580 | if [ -f ${BUILDDIRPREFIX}-gdb/.success ]; then |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 581 | printf "Skipping GDB as it is already built\n" |
Peter Stuge | ceacd77 | 2011-06-09 04:54:16 +0200 | [diff] [blame] | 582 | elif [ $SKIPGDB -eq 1 ]; then |
Stefan Reinauer | 1200ec5 | 2011-11-01 22:39:41 +0100 | [diff] [blame] | 583 | printf "Skipping GDB (GDB support not enabled)\n" |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 584 | else |
| 585 | printf "Building GDB ${GDB_VERSION} ... " |
| 586 | ( |
Patrick Georgi | 3af0aa2 | 2013-09-17 20:59:52 +0200 | [diff] [blame] | 587 | cd ${BUILDDIRPREFIX}-gdb |
Stefan Reinauer | 2c3cd12 | 2011-11-01 21:43:50 +0100 | [diff] [blame] | 588 | export PYTHONHOME=$DESTDIR$TARGETDIR |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 589 | rm -f .failed |
Stefan Reinauer | 2c3cd12 | 2011-11-01 21:43:50 +0100 | [diff] [blame] | 590 | LDFLAGS="-Wl,-rpath,\$\$ORIGIN/../lib/ -L$DESTDIR$TARGETDIR/lib \ |
| 591 | -lpthread -ldl -lutil" \ |
Patrick Georgi | 643c9e8 | 2011-11-04 21:30:49 +0100 | [diff] [blame] | 592 | CC="$CC" CFLAGS="$HOSTCFLAGS -I$DESTDIR$TARGETDIR/include" \ |
Stefan Reinauer | 2c3cd12 | 2011-11-01 21:43:50 +0100 | [diff] [blame] | 593 | ../gdb-${GDB_VERSION}/configure --prefix=$TARGETDIR \ |
| 594 | --target=${TARGETARCH} --disable-werror --disable-nls |
Patrick Georgi | 73166c7 | 2010-04-14 20:42:42 +0000 | [diff] [blame] | 595 | $MAKE $JOBS || touch .failed |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 596 | $MAKE install DESTDIR=$DESTDIR || touch .failed |
| 597 | if [ ! -f .failed ]; then touch .success; fi |
Patrick Georgi | 3af0aa2 | 2013-09-17 20:59:52 +0200 | [diff] [blame] | 598 | ) > ${BUILDDIRPREFIX}-gdb/crossgcc-build.log 2>&1 |
| 599 | test -r ${BUILDDIRPREFIX}-gdb/.failed && printf "${RED}failed${NC}\n" || \ |
Stefan Reinauer | 2c3cd12 | 2011-11-01 21:43:50 +0100 | [diff] [blame] | 600 | printf "${green}ok${NC}\n" |
Patrick Georgi | 3af0aa2 | 2013-09-17 20:59:52 +0200 | [diff] [blame] | 601 | test -r ${BUILDDIRPREFIX}-gdb/.failed && exit 1 |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 602 | fi |
| 603 | |
Patrick Georgi | 6e61ad3 | 2012-05-12 23:19:30 +0200 | [diff] [blame] | 604 | if [ -f $IASL_DIR/source/compiler/.success ]; then |
Marc Jones | 2aac3f6 | 2011-08-08 16:07:50 -0600 | [diff] [blame] | 605 | printf "Skipping IASL as it is already built\n" |
| 606 | else |
| 607 | printf "Building IASL ${IASL_VERSION} ... " |
| 608 | ( |
Idwer Vollering | 6b11c8b | 2012-11-15 21:14:36 +0100 | [diff] [blame] | 609 | cd $IASL_DIR/generate/unix |
Stefan Reinauer | 4266b92 | 2012-12-05 16:18:32 -0800 | [diff] [blame] | 610 | rm -f .failed |
Marc Jones | 2aac3f6 | 2011-08-08 16:07:50 -0600 | [diff] [blame] | 611 | CFLAGS="$HOSTCFLAGS" |
Stefan Reinauer | 0d2119d | 2013-07-10 14:27:56 -0700 | [diff] [blame] | 612 | HOST="_LINUX" |
| 613 | test $UNAME = "Darwin" && HOST="_APPLE" |
| 614 | test $UNAME = "FreeBSD" && HOST="_FreeBSD" |
| 615 | test $UNAME = "Cygwin" && HOST="_CYGWIN" |
| 616 | HOST="$HOST" OPT_CFLAGS="-O -D_FORTIFY_SOURCE=2" CFLAGS="$CFLAGS" $MAKE CC="$CC" iasl || touch .failed |
Stefan Reinauer | 4266b92 | 2012-12-05 16:18:32 -0800 | [diff] [blame] | 617 | rm -f $DESTDIR$TARGETDIR/bin/iasl || touch .failed |
Zheng Bao | 3c4bd91 | 2013-08-27 10:23:13 +0800 | [diff] [blame] | 618 | cp bin/iasl $DESTDIR$TARGETDIR/bin || touch .failed |
Stefan Reinauer | 4266b92 | 2012-12-05 16:18:32 -0800 | [diff] [blame] | 619 | if [ ! -f .failed ]; then touch .success; fi |
Patrick Georgi | 6e61ad3 | 2012-05-12 23:19:30 +0200 | [diff] [blame] | 620 | ) > $IASL_DIR/source/compiler/crossgcc-build.log 2>&1 |
Stefan Reinauer | 4266b92 | 2012-12-05 16:18:32 -0800 | [diff] [blame] | 621 | test -r $IASL_DIR/generate/unix/.failed && printf "${RED}failed${NC}\n" || \ |
Stefan Reinauer | 2c3cd12 | 2011-11-01 21:43:50 +0100 | [diff] [blame] | 622 | printf "${green}ok${NC}\n" |
Stefan Reinauer | 4266b92 | 2012-12-05 16:18:32 -0800 | [diff] [blame] | 623 | test -r $IASL_DIR/generate/unix/.failed && exit 1 |
Marc Jones | 2aac3f6 | 2011-08-08 16:07:50 -0600 | [diff] [blame] | 624 | fi |
| 625 | |
Zheng Bao | 30b895f | 2013-02-06 18:04:40 +0800 | [diff] [blame] | 626 | rm -f $DESTDIR$TARGETDIR/$0.commit.* |
| 627 | cp $0 $DESTDIR$TARGETDIR/"$0.commit.`git describe`" |
| 628 | |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 629 | if [ $SAVETEMPS -eq 0 ]; then |
| 630 | printf "Cleaning up... " |
Patrick Georgi | 3af0aa2 | 2013-09-17 20:59:52 +0200 | [diff] [blame] | 631 | rm -rf ${GMP_DIR} ${BUILDDIRPREFIX}-gmp |
| 632 | rm -rf ${MPFR_DIR} ${BUILDDIRPREFIX}-mpfr |
| 633 | rm -rf ${MPC_DIR} ${BUILDDIRPREFIX}-mpc |
| 634 | rm -rf ${LIBELF_DIR} ${BUILDDIRPREFIX}-libelf |
| 635 | rm -rf ${BINUTILS_DIR} ${BUILDDIRPREFIX}-binutils |
| 636 | rm -rf ${GCC_DIR} ${BUILDDIRPREFIX}-gcc |
| 637 | rm -rf ${GDB_DIR} ${BUILDDIRPREFIX}-gdb |
| 638 | rm -rf ${EXPAT_DIR} ${BUILDDIRPREFIX}-expat |
| 639 | rm -rf ${PYTHON_DIR} ${BUILDDIRPREFIX}-python |
Marc Jones | 2aac3f6 | 2011-08-08 16:07:50 -0600 | [diff] [blame] | 640 | rm -rf ${IASL_DIR} |
Stefan Reinauer | 074d913 | 2009-09-26 16:43:17 +0000 | [diff] [blame] | 641 | printf "${green}ok${NC}\n" |
| 642 | else |
| 643 | printf "Leaving temporary files around... ${green}ok${NC}\n" |
| 644 | fi |
| 645 | |
| 646 | printf "\n${green}You can now run your $TARGETARCH cross toolchain from $TARGETDIR.${NC}\n" |
| 647 | |
| 648 | |